#	SPDX-License-Identifier: CC-BY-NC-SA-4.0
#
# You need to create a drop-in that sets the 'KEY' Environment var to the key value.
# TODO: Use logger(1) for the error message at end.
[Unit]
Description=Heartbeat for CloudNS
Documentation=https://www.cloudns.net/wiki/article/394/
Documentation=https://www.cloudns.net/wiki/article/41/

[Service]
Type=oneshot
# Environment=KEY=
ExecStart= @bash 'sendHeartbeat' -c \n"\
	declare -a Response\n\
	declare -i retVal\n\
	\n\
	function logit () {\n\
		local -i errno facility priority\n\
		errno=$$1\n\
		shift\n\
		facility=3 # daemon\n\
		case $$((errno)) in\n\
		0)\n\
			priority=6 ;; # info\n\
		*)\n\
			priority=6 ;; # info\n\
		esac\n\
		\n\
		logger --journald < <(\n\
			printf \"%%s=%%s\\n\" \\\n\
				\"SYSLOG_IDENTIFIER\" \"heartbeat-Response\" \\\n\
				\"UNIT\" \"%n\" \\\n\
				\"CODE_FILE\" \"%n\" \\\n\
				\"CODE_FUNC\" \"$$0\" \\\n\
				\"SYSLOG_FACILITY\" $$((facility)) \\\n\
				\"PRIORITY\" $$((priority)) \\\n\
				\"ERRNO\" $$((errno))\n\
			printf \"MESSAGE=%%s\\n\" \\\n\
				\"$$@\"\n\
		)\n\
		exit $$((errno))\n\
	}\n\
	\n\
	if test -z \"$${KEY}\"; then\n\
		exit 6 # EXIT_NOTCONFIGURED - The program is not configured.\n\
	else\n\
		printf -v URL \"%%s?%%s\" \\\n\
			\"https://api.cloudns.net/monitoring/heartbeat/\" \\\n\
			\"key=$${KEY}\"\n\
		mapfile -t Response < <(\n\
			curl --silent \"$${URL}\"\n\
		)\n\
		if test \"$${#Response[@]}\" -eq 1; then\n\
			case \"$${Response[0]}\" in\n\
			'{\"status\":1,\"message\":\"UP check accepted\"}')\n\
				retVal=0 # EXIT_SUCCESS\n\
				logit \\\n\
					$$((retVal)) \\\n\
					\"$${Response[0]}\"\n\
				;;\n\
			esac\n\
		fi\n\
		retVal=65 # EX_DATAERR - Data format error\n\
		logit \\\n\
			$$((retVal)) \\\n\
			\"Got an unrecognized response:\" \\\n\
			\"$${Response[@]}\"\n\
	fi\n\
"
